function [c,ceq] = constraints_J(x)
    n = x(1); PD = x(2); Qp = x(3); Va = x(4);
    
    rho = 1025;
    AeAo = 0.7;
    D = 3;
    Z = 4;
   
    
    
    %% Advance ratio
    if sign(Va) == -1
        Va = 0;
    end            

    if n < 0.2
        J = 0;
    else
        J = Va*(n*D)^(-1);
    end   
    
    %% K_q
    poly_mat_Kq = zeros(47,5);

    poly_mat_Kq(1,1)  = double(0.00379368);
    poly_mat_Kq(2,1)  = double(0.00886523); poly_mat_Kq(2,2) = 2;
    poly_mat_Kq(3,1)  = double(-0.032241); poly_mat_Kq(3,2) = 1; poly_mat_Kq(3,3) = 1;
    poly_mat_Kq(4,1)  = double(0.00344778); poly_mat_Kq(4,3) = 2;
    poly_mat_Kq(5,1)  = double(-0.0408811); poly_mat_Kq(5,3) = 1; poly_mat_Kq(5,4) = 1;
    poly_mat_Kq(6,1)  = double(-0.108009); poly_mat_Kq(6,2) = 1; poly_mat_Kq(6,3) = 1; poly_mat_Kq(6,4) = 1;
    poly_mat_Kq(7,1)  = double(-0.0885381); poly_mat_Kq(7,2) =2; poly_mat_Kq(7,3) = 1; poly_mat_Kq(7,4) = 1;
    poly_mat_Kq(8,1)  = double(0.188561); poly_mat_Kq(8,3) = 2; poly_mat_Kq(8,4) = 1;
    poly_mat_Kq(9,1)  = double(-0.00370871); poly_mat_Kq(9,2) = 1; poly_mat_Kq(9,5) = 1;
    poly_mat_Kq(10,1) = double(0.00513696); poly_mat_Kq(10,3) = 1; poly_mat_Kq(10,5) = 1;
    poly_mat_Kq(11,1) = double(0.0209449); poly_mat_Kq(11,2) = 1; poly_mat_Kq(11,3) = 1; poly_mat_Kq(11,5) = 1;
    poly_mat_Kq(12,1) = double(0.00474319); poly_mat_Kq(12,2) = 2; poly_mat_Kq(12,3) = 1; poly_mat_Kq(12,5) = 1;
    poly_mat_Kq(13,1) = double(-0.00723408); poly_mat_Kq(13,2) = 2; poly_mat_Kq(13,4) = 1; poly_mat_Kq(13,5) = 1;
    poly_mat_Kq(14,1) = double(0.00438388); poly_mat_Kq(14,2) = 1; poly_mat_Kq(14,3) = 1; poly_mat_Kq(14,4) = 1; poly_mat_Kq(14,5) = 1;
    poly_mat_Kq(15,1) = double(-0.0269403); poly_mat_Kq(15,3) = 2; poly_mat_Kq(15,4) = 1; poly_mat_Kq(15,5) = 1;
    poly_mat_Kq(16,1) = double(0.0558082); poly_mat_Kq(16,2) = 3; poly_mat_Kq(16,4) = 1;
    poly_mat_Kq(17,1) = double(0.0161886); poly_mat_Kq(17,3) = 3; poly_mat_Kq(17,4) = 1;
    poly_mat_Kq(18,1) = double(0.00318086); poly_mat_Kq(18,2) = 1; poly_mat_Kq(18,3) = 3; poly_mat_Kq(18,4) = 1;
    poly_mat_Kq(19,1) = double(0.015896); poly_mat_Kq(19,4) = 2;
    poly_mat_Kq(20,1) = double(0.0471729); poly_mat_Kq(20,2) = 1; poly_mat_Kq(20,4) = 2;
    poly_mat_Kq(21,1) = double(0.0196283); poly_mat_Kq(21,2) = 3; poly_mat_Kq(21,4) = 2;
    poly_mat_Kq(22,1) = double(-0.0502782); poly_mat_Kq(22,3) = 1; poly_mat_Kq(22,4) = 2;
    poly_mat_Kq(23,1) = double(-0.030055); poly_mat_Kq(23,2) = 3; poly_mat_Kq(23,3) = 1; poly_mat_Kq(23,4) = 2;
    poly_mat_Kq(24,1) = double(0.0417122); poly_mat_Kq(24,2) = 2; poly_mat_Kq(24,3) = 2; poly_mat_Kq(24,4) = 2;
    poly_mat_Kq(25,1) = double(-0.0397722); poly_mat_Kq(25,3) = 3; poly_mat_Kq(25,4) = 2;
    poly_mat_Kq(26,1) = double(-0.00350024); poly_mat_Kq(26,3) = 6; poly_mat_Kq(26,4) = 2;
    poly_mat_Kq(27,1) = double(-0.0106854); poly_mat_Kq(27,2) = 3; poly_mat_Kq(27,5) = 1;
    poly_mat_Kq(28,1) = double(0.00110903); poly_mat_Kq(28,2) = 3; poly_mat_Kq(28,3) = 3; poly_mat_Kq(28,5) = 1;
    poly_mat_Kq(29,1) = double(-0.000313912); poly_mat_Kq(29,3) = 6; poly_mat_Kq(29,5) = 1;
    poly_mat_Kq(30,1) = double(0.0035985); poly_mat_Kq(30,2) = 3; poly_mat_Kq(30,4) = 1; poly_mat_Kq(30,5) = 1;
    poly_mat_Kq(31,1) = double(-0.00142121); poly_mat_Kq(31,3) = 6; poly_mat_Kq(31,4) = 1; poly_mat_Kq(31,5) = 1;
    poly_mat_Kq(32,1) = double(-0.00383637); poly_mat_Kq(32,2) = 1; poly_mat_Kq(32,4) = 2; poly_mat_Kq(32,5) = 1;
    poly_mat_Kq(33,1) = double(0.0126803); poly_mat_Kq(33,3) = 2; poly_mat_Kq(33,4) = 2; poly_mat_Kq(33,5) = 1;
    poly_mat_Kq(34,1) = double(-0.00318278); poly_mat_Kq(34,2) = 2; poly_mat_Kq(34,3) = 3; poly_mat_Kq(34,4) = 2; poly_mat_Kq(34,5) = 1;
    poly_mat_Kq(35,1) = double(0.00334268); poly_mat_Kq(35,3) = 6; poly_mat_Kq(35,4) = 2; poly_mat_Kq(35,5) =1;
    poly_mat_Kq(36,1) = double(-0.00183491); poly_mat_Kq(36,2) = 1; poly_mat_Kq(36,3) = 1; poly_mat_Kq(36,5) = 2;
    poly_mat_Kq(37,1) = double(0.000112451); poly_mat_Kq(37,2) = 3; poly_mat_Kq(37,3) = 2; poly_mat_Kq(37,5) = 2;
    poly_mat_Kq(38,1) = double(-0.0000297228); poly_mat_Kq(38,2) = 3; poly_mat_Kq(38,3) = 6; poly_mat_Kq(38,5) = 2;
    poly_mat_Kq(39,1) = double(0.000269551); poly_mat_Kq(39,2) = 1; poly_mat_Kq(39,4) = 1; poly_mat_Kq(39,5) = 2;
    poly_mat_Kq(40,1) = double(0.00083265); poly_mat_Kq(40,2) = 2; poly_mat_Kq(40,4) = 1; poly_mat_Kq(40,5) = 2;
    poly_mat_Kq(41,1) = double(0.00155334); poly_mat_Kq(41,3) = 2; poly_mat_Kq(41,4) = 1; poly_mat_Kq(41,5) = 2;
    poly_mat_Kq(42,1) = double(0.000302683); poly_mat_Kq(42,3) = 6; poly_mat_Kq(42,4) = 1; poly_mat_Kq(42,5) = 2;
    poly_mat_Kq(43,1) = double(-0.0001843) ; poly_mat_Kq(43,4) = 2; poly_mat_Kq(43,5) = 2;
    poly_mat_Kq(44,1) = double(-0.000425399); poly_mat_Kq(44,3) = 3; poly_mat_Kq(44,4) = 2; poly_mat_Kq(44,5) = 2;
    poly_mat_Kq(45,1) = double(0.0000869243); poly_mat_Kq(45,2) = 3; poly_mat_Kq(45,3) = 3; poly_mat_Kq(45,4) = 2; poly_mat_Kq(45,5) = 2;
    poly_mat_Kq(46,1) = double(-0.0004659); poly_mat_Kq(46,3) = 6; poly_mat_Kq(46,4) = 2; poly_mat_Kq(46,5) = 2;
    poly_mat_Kq(47,1) = double(0.0000554194); poly_mat_Kq(47,2) = 1; poly_mat_Kq(47,3) = 6; poly_mat_Kq(47,4) = 2; poly_mat_Kq(47,5) = 2;


    temp_storage_Kq = zeros(1,length(poly_mat_Kq));
    for m = 1:length(poly_mat_Kq)
            temp_storage_Kq(m) = poly_mat_Kq(m,1)*J^(poly_mat_Kq(m,2)) ...
                *PD^(poly_mat_Kq(m,3))*AeAo^(poly_mat_Kq(m,4))*Z^(poly_mat_Kq(m,5));
    end
    K_q = sum(temp_storage_Kq);

    
    %% Thrust constraint
    
    c = [];

    ceq = Qp - rho*D^5*n^2*K_q;
           
end
        
    