classdef engine < hgsetget
    
    properties
        Kp = 10000;       % Proportional gain
        Ki = 1000;        % Integral gain
        max_torque = 7e6; % The maximum value of torque
        Qm;               % Torque produced
    end
    
    methods
        function [torque_prod] = engine_torque(obj,error,error_int)
            Qm_temp = (error * obj.Kp + error_int * obj.Ki);
            if sign(error) == -1       % Makes is so that the motor will not output torque if the reference is exceeded
                torque_prod = 0;
            elseif Qm_temp > obj.max_torque; % Upper limit
                torque_prod = obj.max_torque;
                set(obj,'Ki',0);
            else
                torque_prod = Qm_temp;
                set(obj,'Ki',1000);
            end
            set(obj,'Qm',torque_prod);
        end
    end
end